/*****************************************************************
 * Copyright (c) ParaSoft Corporation 1991.  All rights reserved.*
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft       *
 * The copyright notice above does not evidence any              *
 * actual or intended publication of such source code.           *
 *****************************************************************/

#include "extern.h"

int ac_in = 0;
int se_in_parse_ArrayConstructor = 0;

static U_DEFINE_STACK (aclist, ArrCons*, 10)

static Node *ac_len (), *ac_len_value ();
static Etype *ac_loop_etype (), *ac_value_etype ();

static ArrCons *ac_malloc_c (temp, list)
Node *temp, *list;
{
	ArrCons *ac = (ArrCons*) U_malloc (sizeof (ArrCons));

	ac->temp = temp;
	ac->list = list;

	return ac;
}

static Etype *ac_loop_etype (value)
Node *value;
{
	Node *list = value->ImpliedDo.ImpliedValueList, *temp;
	Etype *etype;

	for (LIST_LOOP (value, list, temp)) {

		if (LIST_FIRST (value, list)) {
			etype = ac_value_etype (value);
		}
		else {
			if (etype_ne (etype, ac_value_etype (value)))
				etype = EN;
		}
	}

	return etype;
}

static Etype *ac_value_etype (value)
Node *value;
{
	Etype *etype;

	switch (value->com.type) {

	case IMPLIED_DO:
		etype = ac_loop_etype (value);
		break;
	
	default:
		etype = value->com.typ->etype;
	}

	return etype;
}

static ac_write_expr (value, Num, name)
Node *value, *Num;
char *name;
{
	if (value->com.typ->shape == SN
	||  value->com.typ->shape == 0) {
		ac_write_scalar (value, Num, name);
	}
	else { /* it may be non-conformal, so we have to do it by hand */
		ac_write_array (value, Num, name);
	}
}

static Node *ac_write_aclist (list, Num, name)
Node *list, *Num;
char *name;
{
	Node *value, *listtemp;

	list = list_invert (list);

	for (LIST_LOOP (value, list, listtemp)) {
		if (value->com.type == IMPLIED_DO) {
			ac_write_acido (value, Num, name);
		}
		else {
			ac_write_expr (value, Num, name);
		}

		Num = make_DumExpr_PIN (Num, &Plus, ac_len_value (value));
	}
}

static ac_write_scalar (value, Num, name)
Node *value, *Num;
char *name;
{
	Node *sub, *sublist, *arrsec;

	sub = make_Subscript (Num, NN, NN);
	sublist = make_List (&sub, 1, SUBSCRIPT_LIST);
	arrsec = make_ArraySection (make_Name (name), sublist);
	parse_ArraySection (arrsec);

	ostart ();
	otab ();
	write_pass (arrsec);
	ochb ('=');
	write_pass (value);
	odon ();
	oend ();
}

static ac_write_array (value, Num, name)
Node *value, *Num;
char *name;
{
	T_Entry *entry;
	Node *temp, *sublist, *sub, *listtemp;

	ostart ();
	otab ();
	array_dos (value->com.typ);

	sublist = typ_shape_to_sublist (value->com.typ->shape);
	temp = make_ArraySection (make_Name (name), sublist);
	temp->com.typ = value->com.typ;

	for (LIST_LOOP (sub, sublist, listtemp))
		if (LIST_LAST (listtemp)) {
			sub->Subscript.Expr1 = make_DumExpr_PIN (Num, &Plus, sub->Subscript.Expr);
			sub->Subscript.Expr1 = make_DumExpr_PIN (sub->Subscript.Expr1, &Minus, Node_1);
			sub->Subscript.Expr = Num;
		}	
	
	otab ();
	write_pass (temp);
	ochb ('=');
	write_pass (value);
	odon ();

	array_enddos (value->com.typ);
	odon ();
	oend ();
}

static ac_write_acido (value, Num, name)
Node *value, *Num;
char *name;
{
	Node *list;
	struct S_ImpliedDoControl *ido = &value->ImpliedDo.ImpliedDoControl->ImpliedDoControl;
	Node *Num_do, *Len_do;

	ostart ();
	write_ImpliedDoControl_head (value->ImpliedDo.ImpliedDoControl);
	oend ();

	list = value->ImpliedDo.ImpliedValueList;
	Len_do = ac_len (list);

	Num_do = make_DumExpr_PIN (ido->Name, &Minus, ido->Expr);

	if (ido->Expr2 != NN)
		Num_do = make_DumExpr_PIN (Num_do, &Slash, ido->Expr2);

	if (Len_do != Node_1)
		Num_do = make_DumExpr_PIN (Len_do, &Times, Num_do);

	Num_do = make_DumExpr_PIN (Num, &Plus, Num_do);

	ac_write_aclist (list, Num_do, name);

	ostart ();
	otab ();
	oEND_FORALL ();
	odon ();
	oend ();
}

write_ArrayConstructor (ac)
ArrCons *ac;
{
	Node *temp = ac->temp, *list = ac->list, *var;
	Node *Num, *valshape;

	ac_in++;
	ac_write_aclist (list, Node_1, temp->com.str);
	ac_in--;
}

Node *parse_ArrayConstructor (root)
Node *root;
{
	Node *list = root->ArrayConstructor.AcValueList;

	Node *value, *temp, *Nlen, *stmt, *statement, *ilist;
	Typ *typ;
	ArrCons *ac;
	Etype *etype = EN;
	int num;
	double val;

	ilist = list_invert (list);
	num = 0;
	for (LIST_LOOP (value, ilist, temp)) {
		num++;

		if (value->com.type == DUM_ARR_CONS || value->com.type == ARRAY_SECTION)
			array_num_index_set (1);  /* because the AssigStmt will not be parsed */

		if (etype == EN) {
			if ((etype = ac_value_etype (value)) == EN) {
				sprintf (serr
				, "element %d in ARRAY CONSTRUCTOR doesn't have a unique type"
				, num);
				fatal (serr);  /* E_4_13_6 */
			}
		}
		else {
			if (etype_ne (etype, ac_value_etype (value))) {
				sprintf (serr, "element %d in ARRAY CONSTRUCTOR is not of type %s"
				, num, etype_name (etype));
				fatal (serr);  /* E_4_13_6 */
			}
		}
	}

	if (etype == EN)
		etype = Etype_INTEGER_0; /* ER */

	Nlen = ac_len (list);

/* se_... is necesary because temp_make_len will call parse_EntityDecl and
   if we are in 
	integer, dimension (3) :: arr = [1, 2]
   se_AttrList will be (3) and we will get an error because we are actually
   parsing the declaration
	integer temp (2)
*/

	se_in_parse_ArrayConstructor = 1;
	temp = temp_make_len (etype, Nlen, 1);
	se_in_parse_ArrayConstructor = 0;

	ac = ac_malloc_c (temp, list);

	if (ac->isconstant = expr_is_constant (root, &val)) {
		SET_constant (lookup_loc (temp->com.str));
	}

	U_stack_push_aclist (ac);

	if (!ac->isconstant) {
		root = make (DUM_ARR_CONS);
		root->DumArrCons.Expr = temp;
		root->com.typ = temp->com.typ;
		root->DumArrCons.ac = ac;
	}
	else
		root = temp;

	return root;
}

static Node *ac_len_value (value)
Node *value;
{
	Node *ido, *expr;
	Node *ilen, *Len_do;

	if (value->com.type == IMPLIED_DO) {
		ido = value->ImpliedDo.ImpliedDoControl;

		ilen = make_DumExpr_PIN (ido->ImpliedDoControl.Expr1, &Minus
		                        ,ido->ImpliedDoControl.Expr);

		if ((expr = ido->ImpliedDoControl.Expr2) != NN)
			ilen = make_DumExpr_PIN (ilen, &Slash, expr);

		ilen = make_DumExpr_parse (ilen, &Plus, Node_1);

		if ((Len_do = ac_len (value->ImpliedDo.ImpliedValueList)) != Node_1)
			ilen = make_DumExpr_PIN (ilen, &Times, Len_do);
	}
	else {
		if (value->com.typ->shape == SN
		||  value->com.typ->shape == 0) {
			ilen = Node_1;
		}
		else {
			ilen = typ_shape_size (value->com.typ->shape);
		}
	}

	return ilen;
}

static Node *ac_len (list)
Node *list;
{
	Node *value, *temp;
	Node *len = NN, *ilen;

	for (LIST_LOOP (value, list, temp)) {
		ilen = ac_len_value (value);

		if (len == NN)
			len = make_DumExpr_1_PIN (ilen);
		else
			len = make_DumExpr_PIN (len, &Plus, ilen);
	}

	return len;
}

ac_enddecl_write ()
{
	int i;

	for (i = 0; i < aclist_top; i++)
		if (aclist[i]->isconstant)
			write_ArrayConstructor (aclist[i]);
}

static ac_value_is_constant (value)
Node *value;
{
	double val;

	if (value->com.type == IMPLIED_DO) {
		struct S_ImpliedDoControl *ido
		                       = &value->ImpliedDo.ImpliedDoControl->ImpliedDoControl;

		if (ac_list_is_constant (value->ImpliedDo.ImpliedValueList)
		&&  expr_is_constant (ido->Expr, &val)
		&&  expr_is_constant (ido->Expr1, &val)
		&&  expr_is_constant (ido->Expr2, &val))
			return 1;
		else  /*!!! could try to find out if all variables in list are the loop index */
			return 0;
	}
	else {
		return expr_is_constant (value, &val);
	}
}

static ac_list_is_constant (list)
Node *list;
{
	Node *value, *temp;

	for (LIST_LOOP (value, list, temp))
		if (!ac_value_is_constant (value))
			return 0;

	return 1;
}

ac_is_constant (ac)
Node *ac;
{
	return ac_list_is_constant (ac->ArrayConstructor.AcValueList);
}

ac_end_write ()
{
	U_stack_clear_aclist ();
}
/**************************** W R I T E **********************************/

write_DumArrCons (node)
Node *node;
{
	if (node->DumArrCons.ac->isconstant == 0) {
		ostart ();
		write_ArrayConstructor (node->DumArrCons.ac);
		oend ();
	}

	write_pass (node->DumArrCons.Expr);
}

/* BOZKUS */
/*This is to make temp arrays which is needed for PARTI interfaces */
Node *temp_for_parti(etype,len)
Etype *etype;
int len;
{
  Node *Nvalue, *temp;
  temp = search(etype,len);
  if(temp==NN) {
        Nvalue=make_IntegerConstant(len);
        temp = temp_make_len(etype,Nvalue,1);
      }
  return temp;
}
